package iterators;

class Node<T>
{
	private Node<T> next, prev;
	private T cont;

	Node(T theC)
	{
		next = prev = null;
		cont = theC;
	}

	Node<T> getNext()
	{
		return this.next;
	}

	Node<T> getPrev()
	{
		return this.prev;
	}

	T getCont()
	{
		return this.cont;
	}

	void setNext(Node<T> theNext)
	{
		this.next = theNext;
	}

	void setPrev(Node<T> thePrev)
	{
		this.prev = thePrev;
	}

	T setCont(T theCont)
	{
		T tmp = this.cont;
		this.cont = theCont;
		return tmp;
	}

	public boolean equals(Object o)
	{
		Node<T> n = (Node<T>)o;
		if(o == null)
		{
			return cont==null;
		}
		else
		{
			return o.equals(cont);
		}
	}

	public int hashCode()
	{
		return this.toString().hashCode();
	}

	public String toString()
	{
		if(cont == null)
		{
			return "null";
		}
		return cont.toString();
	}
}
