package mediateca;

import java.util.*;
import java.io.*;

public class Mediateca
{
	Map<String, List<Media>> titoli;
	Map<Integer, List<Media>> anni;

	Scanner sc = null;

	public Mediateca()
	{
		titoli = new HashMap<String,List<Media>>();
		anni = new HashMap<Integer,List<Media>>();
	}

	public static void main(String[] argv)
	{
		(new Mediateca()).exec(argv);
	}

	void exec(String[] argv)
	{
		sc = new Scanner(System.in);
		while(true)
		{
			leggi();
			System.out.println(titoli);
			System.out.println(anni);
		}
	}

	void leggi()
	{
		System.out.print("nome file ? > ");
		String nome = sc.nextLine();
		Scanner sc2 = null;
		try
		{
			sc2 = new Scanner(new File(nome));
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			return;
		}
		Media m = null;
		try
		{
			Class<? extends Media> clazz = (Class<? extends Media>)Class.forName(sc2.nextLine());
			m = clazz.newInstance();
			boolean retval = ((Populatable)m).populate(sc2);
			if(retval)
			{
				List<Media> l = titoli.get(m.titolo);
				if(l == null)
				{
					l = new LinkedList<Media>();
					titoli.put(m.titolo, l);
				}
				l.add(m);

				l = anni.get(new Integer(m.annoPrimaPub));
				if(l == null)
				{
					l = new LinkedList<Media>();
					anni.put(new Integer(m.annoPrimaPub), l);
				}
				l.add(m);
				//Collections.sort(l);
			}
		}
		catch(ClassNotFoundException cnfe)
		{
			cnfe.printStackTrace();
			return;
		}
		catch(Exception e)
		{
			// NON FATELO MAI, ma io sono pigro...
			e.printStackTrace();
			return;
		}
		sc2.close();
	}
}
